package com.goomood.phm.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.goomood.phm.domain.KGraphEntity;

import java.util.List;

public interface IKGraphEntityService {

    /**
     * 查询知识图谱实体关系
     *
     * @param id 知识图谱实体关系主键
     * @return 知识图谱实体关系
     */
    KGraphEntity selectById(Long id);

    /**
     * 查询知识图谱实体关系列表
     *
     * @param po 知识图谱实体关系Bo
     * @return 知识图谱实体关系集合
     */
    List<KGraphEntity> selectList(KGraphEntity po);

    /**
     * 查询知识图谱实体关系列表
     *
     * @param taskId TaskId
     * @return 知识图谱实体关系集合
     */
    List<KGraphEntity> selectListByTaskId(Long taskId);

    /**
     * 分页查询知识图谱实体关系列表
     *
     * @param kGraphEntityBo 知识图谱实体关系Bo
     * @return 分页知识图谱实体关系集合
     */
    Page<KGraphEntity> selectPage(KGraphEntity kGraphEntityBo);

    /**
     * 新增知识图谱实体关系
     *
     * @param po 知识图谱实体关系Bo
     * @return 结果:true 操作成功，false 操作失败
     */
    void insert(KGraphEntity po);

    /**
     * 新增知识图谱实体关系
     *
     * @param kGraphEntityList 知识图谱实体关系Bo
     * @return 结果:true 操作成功，false 操作失败
     */
    boolean saveBatch(List<KGraphEntity> kGraphEntityList);

    /**
     * 新增知识图谱实体关系，前台提供主键值，一般用于导入的场合
     *
     * @param po 知识图谱实体关系po
     * @return 结果:true 操作成功，false 操作失败
     */
    boolean insertWithPk(KGraphEntity po);

    /**
     * 修改知识图谱实体关系
     *
     * @param po 知识图谱实体关系po
     * @return 结果:true 更新成功，false 更新失败
     */
    boolean update(KGraphEntity po);

    /**
     * 批量删除知识图谱实体关系
     *
     * @param ids 需要删除的知识图谱实体关系主键集合
     * @return 结果:true 删除成功，false 删除失败
     */
    boolean deleteByIds(Long[] ids);
}
